instruction_template: |-
  {%- set ns = namespace(found=false) -%}
  {%- for message in messages -%}
      {%- if message['role'] == 'system' -%}
          {%- set ns.found = true -%}
      {%- endif -%}
  {%- endfor -%}
  {%- if not ns.found -%}
      {{- '' + '' + '' -}}
  {%- endif %}
  {%- for message in messages %}
      {%- if message['role'] == 'system' -%}
          {{- '' + message['content'] + '' -}}
      {%- else -%}
          {%- if message['role'] == 'user' -%}
              {{-'GPT4 User: ' + message['content'] + '<|end_of_turn|>'-}}
          {%- else -%}
              {{-'GPT4 Assistant: ' + message['content'] + '<|end_of_turn|>' -}}
          {%- endif -%}
      {%- endif -%}
  {%- endfor -%}
  {%- if add_generation_prompt -%}
      {{-'GPT4 Assistant:'-}}
  {%- endif -%}

